# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class MoveObjects(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'objects_type': 'str',
        'source': 'str',
        'target': 'str',
        'token': 'str',
        'uid_token': 'str'
    }

    attribute_map = {
        'objects_type': 'objects-type',
        'source': 'source',
        'target': 'target',
        'token': 'token',
        'uid_token': 'uid-token'
    }

    def __init__(self, objects_type='item', source=None, target=None, token=None, uid_token=None, local_vars_configuration=None):  # noqa: E501
        """MoveObjects - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._objects_type = None
        self._source = None
        self._target = None
        self._token = None
        self._uid_token = None
        self.discriminator = None

        if objects_type is not None:
            self.objects_type = objects_type
        self.source = source
        self.target = target
        if token is not None:
            self.token = token
        if uid_token is not None:
            self.uid_token = uid_token

    @property
    def objects_type(self):
        """Gets the objects_type of this MoveObjects.  # noqa: E501

        The objects type to move (item/auth_method/role)  # noqa: E501

        :return: The objects_type of this MoveObjects.  # noqa: E501
        :rtype: str
        """
        return self._objects_type

    @objects_type.setter
    def objects_type(self, objects_type):
        """Sets the objects_type of this MoveObjects.

        The objects type to move (item/auth_method/role)  # noqa: E501

        :param objects_type: The objects_type of this MoveObjects.  # noqa: E501
        :type: str
        """

        self._objects_type = objects_type

    @property
    def source(self):
        """Gets the source of this MoveObjects.  # noqa: E501

        Source path to move the objects from  # noqa: E501

        :return: The source of this MoveObjects.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this MoveObjects.

        Source path to move the objects from  # noqa: E501

        :param source: The source of this MoveObjects.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and source is None:  # noqa: E501
            raise ValueError("Invalid value for `source`, must not be `None`")  # noqa: E501

        self._source = source

    @property
    def target(self):
        """Gets the target of this MoveObjects.  # noqa: E501

        Target path to move the objects to  # noqa: E501

        :return: The target of this MoveObjects.  # noqa: E501
        :rtype: str
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this MoveObjects.

        Target path to move the objects to  # noqa: E501

        :param target: The target of this MoveObjects.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and target is None:  # noqa: E501
            raise ValueError("Invalid value for `target`, must not be `None`")  # noqa: E501

        self._target = target

    @property
    def token(self):
        """Gets the token of this MoveObjects.  # noqa: E501

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :return: The token of this MoveObjects.  # noqa: E501
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """Sets the token of this MoveObjects.

        Authentication token (see `/auth` and `/configure`)  # noqa: E501

        :param token: The token of this MoveObjects.  # noqa: E501
        :type: str
        """

        self._token = token

    @property
    def uid_token(self):
        """Gets the uid_token of this MoveObjects.  # noqa: E501

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :return: The uid_token of this MoveObjects.  # noqa: E501
        :rtype: str
        """
        return self._uid_token

    @uid_token.setter
    def uid_token(self, uid_token):
        """Sets the uid_token of this MoveObjects.

        The universal identity token, Required only for universal_identity authentication  # noqa: E501

        :param uid_token: The uid_token of this MoveObjects.  # noqa: E501
        :type: str
        """

        self._uid_token = uid_token

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MoveObjects):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MoveObjects):
            return True

        return self.to_dict() != other.to_dict()
